import { ViewBase } from '../../libappbase/viewbase';
import { UIWaitSOP } from '../../libappsop/objectsop';
import { ButtonProductsContextMenuItem } from '../actionbarpages/abp.data';
import { AppMP } from '../appmp';
import { FormProduct } from '../forms/form.product';

export class ViewProduct extends ViewBase implements UIWaitSOP {
  public readonly name = 'View Products';
  public readonly viewPath = 'Data > Products > Products';

  public frmProduct = new FormProduct();

  public async switchTo(): Promise<void> {
    const appMP = AppMP.getInstance();

    // wait until abp data is visible
    await appMP.abpData.isVisible();
    // Open data action bar page
    await appMP.abpData.click();
    // Click on Products submenu in Products context menu
    await appMP.abpData.btnProducts.clickDropdownAndSelectMenu(ButtonProductsContextMenuItem.Products);

    await this.waitUILoaded();
  }

  public async waitUILoaded(): Promise<void> {
    // Wait until form Product form is present
    await this.frmProduct.waitUntilPresent();
  }
}
